String[][] rulesB = {{"F", "FF-[-F+F+F]+[+F-F-F]"}, {"X", "F[+X][-X]FX"}, {"-", "-"}, {"+", "+"}, {"[", "["}, {"]", "]"}};
String[][] rulesBVines = {{"F", "FF-[-F+F+F]+[+F-F-F]"}, {"X", "F[+X][-X]FX"}, {"-", "-"}, {"+", "+"}};
float originXs = -1;

public void botanicalForm(char bOrV){
  LSystem l = null;
  var t = new Turtle(this);
  t.penUp();
      
  // if vines
  if (bOrV == 'v'){
    l = new LSystem(5, 22.5, rulesBVines, "FF", 'v');
    l.iterate(3);
    originXs = width/random(12, 31);
    background(198, 83, 83); // brick wall
    t.goToPoint(0, 0);
    t.setHeading(180);
  }
  
  // if bush
  else {
    l = new LSystem(5, 22.5, rulesB, "FF", 'b');
    l.iterate(4);
    background(153, 102, 0); // dirt color
    t.goToPoint(width/2, height - 200);
    t.setHeading(-90);
  }
  
  t.penDown();
  stroke(0, 102, 0); // plant color

  l.drawLSystem(t);
}

public void vineAdjust(Turtle t, LSystem l, int drawCount){
  // make the turtle be at the top of the screen facing down
  t.penUp();
  t.goToPoint(drawCount*originXs, 0); // back to the top but over a bit from the last vine
  t.setHeading(180); // face down
  t.penDown();
  l.drawLSystem(t);
}

public void bushAdjust(Turtle t, LSystem l, int drawCount){
  // make the turtle be at the bottom of the screen facing up
  t.penUp();
  t.goToPoint(width/2, height - 200); // back to bottom center with a different heading
  t.setHeading(-90 + (drawCount * 36)); // face down
  t.penDown();
  l.drawLSystem(t);
}
