public class LSystem {
  String axiom;
  String computedWord;
  float size, angle;
  int drawCount;
  char runningSystem;
  String[][] rules;
  
  public LSystem(float size, float angle, String[][] rules, String axiom, char system){
    this.size = size;
    this.angle = angle;
    this.rules = rules;
    this.axiom = axiom;
    this.runningSystem = system;
    drawCount = 0;
    computedWord = axiom;
  }
  
  public void iterate(int iterations){
    String tempWord;
    println("Starting word: " + computedWord);
    for (int i = 0; i < iterations; i++){
      tempWord = computedWord;
      computedWord = "";
      for (int j = 0; j < tempWord.length(); j++){
        char c = tempWord.charAt(j);
        for (int k = 0; k < rules.length; k++){
          if (c == rules[k][0].charAt(0)){
            computedWord = computedWord + rules[k][1];
            break;
          }
        }
      }
      
      println("Iteration " + i + ": " + computedWord);
    }
  }
  
  void drawLSystem(Turtle t){
    char c;
    for (int i = 0; i < computedWord.length(); i++){
      c = computedWord.charAt(i);
      
      if (c == 'F'){
        t.forward(size);
      }
      else if (c == 'X'){
        t.forward(size);
      }
      if (c == 'L'){
        t.forward(size);
      }
      else if (c == 'R'){
        t.forward(size);
      }
      else if (c == 'S'){
        polygonHalt(t, 16, 144);
      }
      else if (c == '+'){
        t.right(angle); 
      }
      else if (c == '-'){
        t.left(angle);
      }
      else if (c == '['){
        t.push();
      }
      else if (c == ']'){
        t.pop();
      }
    }
    
    drawCount++;
    BuildUponLSystem(t);
  }
  
  private void BuildUponLSystem(Turtle t){
     if (runningSystem == 'f' && drawCount < 4){
       fractalAdjust(t, this, drawCount);
     }
     
     else if (runningSystem == 'v' && drawCount < originXs){
       vineAdjust(t, this, drawCount);
     }
     
     else if (runningSystem == 'b' && drawCount <= 5){
       bushAdjust(t, this, drawCount);
     }
     
     else if (runningSystem == 'r' && drawCount < spokes){
       roganAdjust(t, this, drawCount);  
     }
   }
}
