/*****************************************
* Large Assignment 1: L-System Lace
* Name:    Michael Nafe
* E-mail:  nafem@unm.edu
* Course:      CS591, Computational Fabrication
* Submitted:    
*
* This program includes 4 different features.
* Press the f key to draw an LSystem fractal
* Press the b key to draw an LSystem botanical form
* Press the s key to draw an L-System that is interpretted with shapes.
* Press the r key to draw a Rogan Brown inspired design
***********************************************/
import processing.pdf.*;
import Turtle.*;

//String[][] rulesDragon = {{"L", "L+R+"}, {"R", "-L-R"}, {"+", "+"}, {"-", "-"}};

void setup(){
  size(1200, 900);
  background(255, 102, 102);
  textFont(createFont("Arial", 16, true), 36);
  fill(255);
  textAlign(CENTER);
  text("Use:\n\tf for fractal\n\tv for vines\n\tb for bush\n\ts for shape interpretted\n\tr for Rogan Brown inspired",
    width/2,
    height/2-200);
  /*
  l = new LSystem(7, 90 , rulesDragon, "L", key); // size, angle, rules, axiom
  l.iterate(11);
  l.drawLSystem(new Turtle(this));*/
}

void draw(){
  
}

void keyPressed(){
  // if fractal
  if (key == 'f' || key == 'F'){
    fractal();
  }
  
  // if botanical vines
  else if(key == 'v' || key == 'V'){
    botanicalForm('v');
  }
  
  // if bush
  else if(key == 'b' || key == 'B'){
    botanicalForm('b'); 
  }
  
  // if shape interpreted LSystem
  else if(key == 's' || key == 'S'){
    shapeInterpreted();
  }
  
  // if Rogan Brown inspired design
  else if(key == 'r' || key == 'R'){
    roganBrown();
  }
}
