String[][] rulesR = {{"F", "FF-[-F+F+F]+[+F-F-F]"}, {"X", "F[+X][-X]FX"}, {"-", "-"}, {"+", "+"}, {"[", "["}, {"]", "]"}};
int spokes = 12; //36;

public void roganBrown(){
  var t = new Turtle(this);
  var l = new LSystem(5, 17, rulesB, "FF", 'r');
  int strokeWeight = 4;
  background(128, 128, 128);
  stroke(255);
    
  // make the circle parts
  for (int radius = 40; radius <= 360; radius+=80){// <= 1280; radius+=80){
    strokeWeight(strokeWeight);
    centeredCircle(t, radius);
    strokeWeight += 2;
  }
  
  // make the spoke vine parts
  strokeWeight(1);
  l.iterate(4);
  l.drawLSystem(t);
}

// use this to make 36 vine spokes
public void roganAdjust(Turtle t, LSystem l, int drawCount){
  // just make a fresh turtle rather than send the one I have back to the center
  t = new Turtle(this);
  t.setHeading(drawCount*30); // 10);
  l.drawLSystem(t);
}

// Uses turtle geometry to draw only a circle of radius radius and return the turtle to its starting position
private void centeredCircle(Turtle t, float radius){
  t.penUp();  
  t.forward(radius);
  t.right(90);
  t.penDown();
  
  // C = 2*PI*r, which means my turtle has to travel 2*PI*r units in 360 "moves", or rather, changes to its heading.
  // Thus, every move must travel 2*PI*radius/360 units. Though with larger and larger radii, the circle
  // will look more and more like a 360 sided polygon than a circle.
  var arcUnit = 2*PI*radius/360;
  for (int i = 0; i < 360; i++){
    t.forward(arcUnit);
    t.right(1);
  }
  
  t.penUp();
  t.right(90);
  t.forward(radius);
  t.right(180); // original heading too
  t.penDown();
}
